	.model tiny
	.radix 10
	.586p

dataseg

usedsocket = 5555h

sdelzp	db	'Text spravy: $'
sdel1	db	'NetAPI Proram nie je nainstalavny ',10,13,'$'
sdel2	db	'Nejde otvorit IPX socket',10,13,'$'
sdel3	db	'Paket prijaty',10,13,'$'
sdel4	db	'Zly paket',10,13,'$'
sdel5	db	'Prijmam, stlac lubovolnu klavesu pre ukoncenie',10,13,'$'
sdelT	db	'Program ukonceny',10,13,'$'
crlf	db	10,13,'$'

ECB    struc                                    ; definice struktury ECB bloku
    Link     dd  0
    ESR      dd  0
    InUse    db  0
    ComCod   db  0
    socket   dw  usedsocket
    IPXwspc  db  4 dup (0)
    DRVwspc  db  12 dup (0)
    LocNoAd  db  6 dup (0FFh)
    FragCnt  dw  1h
    FragDta  dw  0
             dw  0
    FragSiz  dw  200                            ;delka oznamu
ECB    ends

IPXhead    struc                                ;definicia hlavicky IPX paketu
    checksum     dw     0FFFFh
    length_h     dw     0
    transpstrl   db     0
    packettype   db     0
    destnetw     db     4 dup (0)
    destnode     db     6 dup (0FFh)
    destsckt     dw     usedsocket
    srcenetw     db     4 dup (0)
    srcenode     db     6 dup (0FFh)
    srcesckt     dw     usedsocket
IPXhead    ends

STEJNESEG MACRO
    mov   ax,cs                                 ;makro nastavi podla registru CS
    mov   ds,ax                                 ;oba systemove registre DS a ES
    mov   es,ax
    ENDM

codeseg

startupcode

        ORG 100H				;Prekladam od adresy 100h

Run:    jmp     worker                          ;skoc na pocatek programu
ECBr    ECB     <,,,,,,,,,offset IPXr,,>        ;riadiaci blok pro prijem
IPXr    IPXhead <>                              ;maximalni dlzka paketu je 576 byte

dataR   db 546 dup(0)                           ;je 546 byte pre data

totoPSP dw      0

worker: STEJNESEG                               ;nastav segmentove registre podla registru CS
        mov     ax,7A00h                        ;tat sluzba zjisti , je-li
        int     2Fh                             ;API instalovane
        mov     dx,offset sdel1                 ;do DX priprav adresu oznamu
        cmp     al,0FFh                         ;ak je API, pak AL=0FFh
        je      vseOK                           ;preskoc dlouhy skok na chybu
        jmp     error                           ;ohlas chybu a ukonci program
vseOK:  mov     al,0                            ;otevreni soketu tzp 'short live'
        mov     bx,0                            ;sluzba otevreni soketu
        mov     dx,usedsocket                   ;do DX dej cislo soketu
        int     7Ah                             ;a otvori soket pro prijem
	mov     dx,offset sdel2                 ;priprav si chybove hlasenie
	cmp     al,0                            ;ak sa otvoril soket spravne,
	je      pokrac                          ;potom AL=0 a pokracuj dalej
	jmp     error                           ;pokud nejde otvorit, ohlas chybu
                                                ;a ukoci program

pokrac:	mov     dx,offset sdel5                 ;Vypis spravu (prijimam)
        mov     ah,9                            ;sluzba pro tisk retezce
	int     21h                             ;vytiskni tuto zpravu
	mov     ah,62h                          ;sluzba DOSu c. 62
	int     21h                             ;zistenie PSP programu
        mov     totoPSP,bx                      ;a uloz si ho do pameti
        mov     ECBr.FragDta+2,bx               ;a do segmentu dat paketu
        STEJNESEG				;ES=DS=CS
znovu:	mov     ECBr.FragSiz,576		;Uloz maximalnu dlzku prijmanych paketov
						;do dlzky paketu
	mov     si, offset ECBr			;Adresa ECB pre vysielanie
	mov     word ptr [si+4],0		;Nie je definovana ESR
	mov     word ptr [si+6],0		;Vypln adresu ECB nulou
	mov     word ptr [si+22h],1		;FragmentCount=1 t.j. ze v jednom fragmente su data
						;aj hlavicka paketu
	mov	bx,04h				;Cakaj na paket - slu6ba IPX c.3
	push	si				;Uchovaj si segmentove registre
	push    es				;Uchovaj si segmentove registre
	int	7Ah				;Volaj IPX pre prijem paketov
	pop	es				;Obnov si segmentove registre
	pop	si				;Obnov si segmentove registre

neprislo:					;V nekonecnej slucke cakam na paket
	mov     ah,0Bh				;Kontrolujem ci nie je stlacena nejaka klavesa
	int     21h				;Zistujem to sluzbou 0Bh DOSu
	cmp	al,0FFh				;Ak ano tak predcasne ukoncujem program
	je      Termin				;Ukoncujem cinnost programu
        cmp     byte ptr es:[si+8],0		;Testuj hodnotu polozky ECB InUseFlag
        jne     neprislo			;a ak nic neprislo cakaj dalej
        mov     dx,offset sdel3			;Priprav si hlasenie - Prisiel paket

        cmp     byte ptr es:[si+9],0		;Testujem navratovy kod
        je spravne				;Ak je nulovy potom bol paket dobry a preskocim
        mov     dx,offset sdel4			;Hlasenie o zlom pakete
spravne:mov     ah,09h				;Sluzba DOSU c. 09h, vypis text na obrazovku
        int     21h				;Tlacim spravu o pakete
        mov     ax,IPXr.Length_h		;Zistujem dlzku prijatych dat z hlavicky paketu
        mov     cl,ah				;Prehadzujem poradie byte v slove
        mov     ch,al				;pretoze su vo formate vyssi-nizsi
        sub     cx,30d				;a odcitaj dlzku hlavicky
        mov     si,offset dataR			;do registra SI vloz pociatok prijatych dat
        jcxz    nic				;ak je ich dlzka nulova netlac nic
lop:    lodsb					;do AL vloz prvy znak spravy a presun
        mov     dl,al				;ich do registra DL pre tlac
        mov     ah,02				;jedneho znaku - sluzba 02h
        int     21h				;Tlac jednotlivy znak
        loop    lop				;Pokracuj v cykle pre ostatne znaky
						;v CX je pocet znakov
nic:    mov     dx,offset crlf			;Po vytlaceni spravy posun na novy riadok
        mov     ah,09h				;a vytlac znak konca riadku
        int     21h
        jmp     znovu				;Opakuj prijem dalsieho paketu

Termin: mov     ah,08h				;Ak bol preruseny prijem stlacenim klavesy
        int     21h				;potom si precitaj stlacenu klavesu			
        mov     bx,06h				;sluzba 06h zrusenie udalosti prijmu a volaj IPX
        int     7Ah				;pre zrusenie prijmu
        mov     bx,01h				;Sluzba 01h uzatvorenie soketu
        mov     dx,usedsocket			;V DX je cislo soketu
        int     7Ah				;Zatvorim pouzity soket
        mov     dx,offset sdelT			;Do DX vkladam hlasenie o ukonceni tohoto programu

        mov     ah,09h				;Vytlacim koniec programu ho na obrazovku
        int     21h				;Tlacim
        mov     ax,4C00h			;Vraciam sa spat do DOSu
        int     21h				;Vykonavam ukoncenie ....

error:  mov ah,09h				;Ukoncenie programu pri nejakej chybe
        int     21h				;Tlacim chybove hlasenie na obrazovku
        mov     ax,4C01h			;Vraciam ho s chybou 1 do DOSu
        int     21h

	exitcode

	end